"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JavaMatcher = void 0;
const base_1 = require("./base");
class JavaMatcher extends base_1.BaseTerminalDetectionLineMatcher {
    constructor() {
        super(...arguments);
        this.type = base_1.MatcherType.java;
        this.isMultiLine = true;
    }
    /**
     * java 场景，多行，带堆栈信息
     * 1. caused by:
     * 2. xxxException:
     */
    doMatch(styleList) {
        return this.isErrorStack(styleList) || this.isCasuseByError(styleList) || this.isExceptionError(styleList);
    }
    isErrorStack(styleList) {
        return this.isMatched && !!styleList.find((item) => /^\s+at\s/i.test(item.content));
    }
    isCasuseByError(styleList) {
        return !!styleList.find((item) => /caused\sby:/i.test(item.content));
    }
    isExceptionError(styleLIst) {
        return !!styleLIst.find((item) => /\w+Exception:/i.test(item.content));
    }
}
exports.JavaMatcher = JavaMatcher;
//# sourceMappingURL=java.js.map