"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NPMMatcher = void 0;
const ansi_parser_1 = require("../utils/ansi-parser");
const base_1 = require("./base");
class NPMMatcher extends base_1.BaseTerminalDetectionLineMatcher {
    constructor() {
        super(...arguments);
        this.type = base_1.MatcherType.npm;
        this.isMultiLine = true;
        this.maxSpaceLine = 1;
    }
    /**
     * npm 情况
     * 1. 红色 ERR 多行
     */
    doMatch(styleList) {
        return !!styleList.find((style) => /ERR/.test(style.content) && (0, ansi_parser_1.isRedColor)(style));
    }
}
exports.NPMMatcher = NPMMatcher;
//# sourceMappingURL=npm.js.map