"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TerminalAIContribution = void 0;
const tslib_1 = require("tslib");
const di_1 = require("@opensumi/di");
const ide_core_browser_1 = require("@opensumi/ide-core-browser");
const ai_terminal_service_1 = require("./ai-terminal.service");
const terminal_decoration_1 = require("./decoration/terminal-decoration");
const ps1_terminal_service_1 = require("./ps1-terminal.service");
let TerminalAIContribution = class TerminalAIContribution {
    onDidStart() {
        if (this.aiNativeConfigService.capabilities.supportsTerminalDetection) {
            this.aiTerminalService.active();
            this.aiTerminalDecorationService.active();
        }
        if (this.aiNativeConfigService.capabilities.supportsTerminalCommandSuggest) {
            this.ps1TerminalService.active();
        }
    }
};
tslib_1.__decorate([
    (0, di_1.Autowired)(ai_terminal_service_1.AITerminalService),
    tslib_1.__metadata("design:type", ai_terminal_service_1.AITerminalService)
], TerminalAIContribution.prototype, "aiTerminalService", void 0);
tslib_1.__decorate([
    (0, di_1.Autowired)(terminal_decoration_1.AITerminalDecorationService),
    tslib_1.__metadata("design:type", terminal_decoration_1.AITerminalDecorationService)
], TerminalAIContribution.prototype, "aiTerminalDecorationService", void 0);
tslib_1.__decorate([
    (0, di_1.Autowired)(ps1_terminal_service_1.PS1TerminalService),
    tslib_1.__metadata("design:type", ps1_terminal_service_1.PS1TerminalService)
], TerminalAIContribution.prototype, "ps1TerminalService", void 0);
tslib_1.__decorate([
    (0, di_1.Autowired)(ide_core_browser_1.AINativeConfigService),
    tslib_1.__metadata("design:type", ide_core_browser_1.AINativeConfigService)
], TerminalAIContribution.prototype, "aiNativeConfigService", void 0);
TerminalAIContribution = tslib_1.__decorate([
    (0, ide_core_browser_1.Domain)(ide_core_browser_1.ClientAppContribution)
], TerminalAIContribution);
exports.TerminalAIContribution = TerminalAIContribution;
//# sourceMappingURL=terminal-ai.contributon.js.map