declare const DEFAULT_STYLE: {
    color: number;
    isSpecialColor: boolean;
    isRgbColor: boolean;
    is256Color: boolean;
    bgColor: number;
    isSpecialBg: boolean;
    isRgbBg: boolean;
    is256Bg: boolean;
    bold: boolean;
    underline: boolean;
};
export type TextStyle = typeof DEFAULT_STYLE;
export interface TextWithStyle extends TextStyle {
    content: string;
}
export declare enum StyleCode {
    RESET = 0,
    BOLD = 1,
    UNDERLINE = 4,
    RESET_BOLD = 22,
    RESET_UNDERLINE = 24
}
export declare enum ColorCode {
    MODE_RGB = 2,
    MODE_256 = 5,
    BLACK = 30,
    RED = 31,
    GREEN = 32,
    YELLOW = 33,
    BLUE = 34,
    MAGENTA = 35,
    CYAN = 36,
    WHITE = 37,
    SPECIAL_COLOR_MODE = 38,
    RESET_COLOR = 39,
    BLACK_BG = 40,
    RED_BG = 41,
    GREEN_BG = 42,
    YELLOW_BG = 43,
    BLUE_BG = 44,
    MAGENTA_BG = 45,
    CYAN_BG = 46,
    WHITE_BG = 47,
    SPECIAL_BG_MODE = 48,
    RESET_BG = 49,
    BLACK_BRIGHT = 90,
    RED_BRIGHT = 91,
    GREEN_BRIGHT = 92,
    YELLOW_BRIGHT = 93,
    BLUE_BRIGHT = 94,
    MAGENTA_BRIGHT = 95,
    CYAN_BRIGHT = 96,
    WHITE_BRIGHT = 97,
    BLACK_HIGH_INTENSITY = 100,
    RED_HIGH_INTENSITY = 101,
    GREEN_HIGH_INTENSITY = 102,
    BLUE_HIGH_INTENSITY = 104,
    MAGENTA_HIGH_INTENSITY = 105,
    CYAN_HIGH_INTENSITY = 106,
    WHITE_HIGH_INTENSITY = 107
}
export declare function ansiParser(text: string, style?: TextStyle): {
    parts: TextWithStyle[];
    currentStyle: {
        color: number;
        isSpecialColor: boolean;
        isRgbColor: boolean;
        is256Color: boolean;
        bgColor: number;
        isSpecialBg: boolean;
        isRgbBg: boolean;
        is256Bg: boolean;
        bold: boolean;
        underline: boolean;
    };
};
export declare function isRedColor(style: TextStyle): boolean;
export {};
//# sourceMappingURL=ansi-parser.d.ts.map