import { Injector } from '@opensumi/di';
import { Disposable } from '@opensumi/ide-core-common';
import { IChatAgentService } from '../../common';
import { ChatModel, ChatRequestModel } from './chat-model';
export declare class ChatManagerService extends Disposable {
    #private;
    injector: Injector;
    chatAgentService: IChatAgentService;
    constructor();
    startSession(): ChatModel;
    getSession(sessionId: string): ChatModel | undefined;
    clearSession(sessionId: string): void;
    createRequest(sessionId: string, message: string, agentId: string, command?: string): ChatRequestModel | undefined;
    sendRequest(sessionId: string, request: ChatRequestModel, regenerate: boolean): Promise<void>;
    cancelRequest(sessionId: string): void;
}
//# sourceMappingURL=chat-manager.service.d.ts.map