"use strict";
var _ChatResponseModel_instances, _ChatResponseModel_responseParts, _ChatResponseModel_responseContents, _ChatResponseModel_isComplete, _ChatResponseModel_isCanceled, _ChatResponseModel_requestId, _ChatResponseModel_responseText, _ChatResponseModel_errorDetails, _ChatResponseModel_followups, _ChatResponseModel_onDidChange, _ChatResponseModel_updateResponseText, _ChatRequestModel_requestId, _ChatModel_sessionId, _ChatModel_requests;
var ChatModel_1, ChatWelcomeMessageModel_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatSlashCommandItemModel = exports.ChatWelcomeMessageModel = exports.ChatModel = exports.ChatRequestModel = exports.ChatResponseModel = void 0;
const tslib_1 = require("tslib");
const di_1 = require("@opensumi/di");
const ide_core_common_1 = require("@opensumi/ide-core-common");
const htmlContent_1 = require("@opensumi/monaco-editor-core/esm/vs/base/common/htmlContent");
const common_1 = require("../../common");
let ChatResponseModel = class ChatResponseModel extends ide_core_common_1.Disposable {
    get responseParts() {
        return tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f");
    }
    get responseContents() {
        return tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseContents, "f");
    }
    get isComplete() {
        return tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_isComplete, "f");
    }
    get isCanceled() {
        return tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_isCanceled, "f");
    }
    get requestId() {
        return tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_requestId, "f");
    }
    get responseText() {
        return tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseText, "f");
    }
    get errorDetails() {
        return tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_errorDetails, "f");
    }
    get followups() {
        return tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_followups, "f");
    }
    get onDidChange() {
        return tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_onDidChange, "f").event;
    }
    constructor(requestId, session, agentId) {
        super();
        this.session = session;
        this.agentId = agentId;
        _ChatResponseModel_instances.add(this);
        _ChatResponseModel_responseParts.set(this, []);
        _ChatResponseModel_responseContents.set(this, []);
        _ChatResponseModel_isComplete.set(this, false);
        _ChatResponseModel_isCanceled.set(this, false);
        _ChatResponseModel_requestId.set(this, void 0);
        _ChatResponseModel_responseText.set(this, '');
        _ChatResponseModel_errorDetails.set(this, void 0);
        _ChatResponseModel_followups.set(this, void 0);
        _ChatResponseModel_onDidChange.set(this, this.registerDispose(new ide_core_common_1.Emitter()));
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_requestId, requestId, "f");
    }
    updateContent(progress, quiet) {
        var _a;
        if (progress.kind === 'content' || progress.kind === 'markdownContent') {
            const responsePartLength = tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f").length - 1;
            const lastResponsePart = tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f")[responsePartLength];
            if (!lastResponsePart || lastResponsePart.kind !== 'markdownContent') {
                if (progress.kind === 'content') {
                    tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f").push({ content: new htmlContent_1.MarkdownString(progress.content), kind: 'markdownContent' });
                }
                else {
                    tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f").push(progress);
                }
            }
            else if (progress.kind === 'markdownContent') {
                tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f")[responsePartLength] = {
                    content: new htmlContent_1.MarkdownString(lastResponsePart.content.value + progress.content.value),
                    kind: 'markdownContent',
                };
            }
            else {
                tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f")[responsePartLength] = {
                    content: new htmlContent_1.MarkdownString(lastResponsePart.content.value + progress.content, lastResponsePart.content),
                    kind: 'markdownContent',
                };
            }
            tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_instances, "m", _ChatResponseModel_updateResponseText).call(this);
        }
        else if (progress.kind === 'asyncContent') {
            // Add a new resolving part
            const responsePosition = tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f").push(progress) - 1;
            tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_instances, "m", _ChatResponseModel_updateResponseText).call(this);
            (_a = progress.resolvedContent) === null || _a === void 0 ? void 0 : _a.then((content) => {
                // Replace the resolving part's content with the resolved response
                if (typeof content === 'string') {
                    tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f")[responsePosition] = { content: new htmlContent_1.MarkdownString(content), kind: 'markdownContent' };
                }
                else if ((0, htmlContent_1.isMarkdownString)(content)) {
                    tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f")[responsePosition] = { content, kind: 'markdownContent' };
                }
                else {
                    tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f")[responsePosition] = content;
                }
                tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_instances, "m", _ChatResponseModel_updateResponseText).call(this, quiet);
            });
        }
        else if (progress.kind === 'treeData') {
            tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f").push(progress);
            tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_instances, "m", _ChatResponseModel_updateResponseText).call(this, quiet);
        }
        else if (progress.kind === 'component') {
            tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f").push(progress);
            tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_instances, "m", _ChatResponseModel_updateResponseText).call(this, quiet);
        }
    }
    complete() {
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_isComplete, true, "f");
        tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_onDidChange, "f").fire();
    }
    cancel() {
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_isComplete, true, "f");
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_isCanceled, true, "f");
        tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_onDidChange, "f").fire();
    }
    reset() {
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_responseContents, [], "f");
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_responseParts, [], "f");
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_responseText, '', "f");
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_isCanceled, false, "f");
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_isComplete, false, "f");
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_errorDetails, undefined, "f");
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_followups, undefined, "f");
        tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_onDidChange, "f").fire();
    }
    setErrorDetails(errorDetails) {
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_errorDetails, errorDetails, "f");
        tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_onDidChange, "f").fire();
    }
    setFollowups(followups) {
        tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_followups, followups, "f");
        tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_onDidChange, "f").fire();
    }
};
_ChatResponseModel_responseParts = new WeakMap(), _ChatResponseModel_responseContents = new WeakMap(), _ChatResponseModel_isComplete = new WeakMap(), _ChatResponseModel_isCanceled = new WeakMap(), _ChatResponseModel_requestId = new WeakMap(), _ChatResponseModel_responseText = new WeakMap(), _ChatResponseModel_errorDetails = new WeakMap(), _ChatResponseModel_followups = new WeakMap(), _ChatResponseModel_onDidChange = new WeakMap(), _ChatResponseModel_instances = new WeakSet(), _ChatResponseModel_updateResponseText = function _ChatResponseModel_updateResponseText(quiet) {
    tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_responseText, tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f")
        .map((part) => {
        if (part.kind === 'asyncContent') {
            return part.content;
        }
        if (part.kind === 'treeData') {
            return '';
        }
        if (part.kind === 'component') {
            return '';
        }
        return part.content.value;
    })
        .join('\n\n'), "f");
    // 合并连续的 markdown 内容
    const result = [];
    for (const item of tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_responseParts, "f")) {
        const previousItem = result[result.length - 1];
        if (item.kind === 'markdownContent' && (previousItem === null || previousItem === void 0 ? void 0 : previousItem.kind) === 'markdownContent') {
            result[result.length - 1] = {
                content: new htmlContent_1.MarkdownString(previousItem.content.value + item.content.value, {
                    isTrusted: previousItem.content.isTrusted,
                }),
                kind: 'markdownContent',
            };
        }
        else {
            result.push(item);
        }
    }
    tslib_1.__classPrivateFieldSet(this, _ChatResponseModel_responseContents, result, "f");
    if (!quiet) {
        tslib_1.__classPrivateFieldGet(this, _ChatResponseModel_onDidChange, "f").fire();
    }
};
ChatResponseModel = tslib_1.__decorate([
    (0, di_1.Injectable)({ multiple: true }),
    tslib_1.__metadata("design:paramtypes", [String, Object, String])
], ChatResponseModel);
exports.ChatResponseModel = ChatResponseModel;
let ChatRequestModel = class ChatRequestModel {
    get requestId() {
        return tslib_1.__classPrivateFieldGet(this, _ChatRequestModel_requestId, "f");
    }
    constructor(requestId, session, message, response) {
        this.session = session;
        this.message = message;
        this.response = response;
        _ChatRequestModel_requestId.set(this, void 0);
        tslib_1.__classPrivateFieldSet(this, _ChatRequestModel_requestId, requestId, "f");
    }
};
_ChatRequestModel_requestId = new WeakMap();
ChatRequestModel = tslib_1.__decorate([
    (0, di_1.Injectable)({ multiple: true }),
    tslib_1.__metadata("design:paramtypes", [String, Object, Object, ChatResponseModel])
], ChatRequestModel);
exports.ChatRequestModel = ChatRequestModel;
let ChatModel = ChatModel_1 = class ChatModel extends ide_core_common_1.Disposable {
    constructor() {
        super(...arguments);
        _ChatModel_sessionId.set(this, (0, ide_core_common_1.uuid)());
        _ChatModel_requests.set(this, []);
    }
    get sessionId() {
        return tslib_1.__classPrivateFieldGet(this, _ChatModel_sessionId, "f");
    }
    get requests() {
        return tslib_1.__classPrivateFieldGet(this, _ChatModel_requests, "f");
    }
    addRequest(message) {
        const requestId = 'request_' + ChatModel_1.requestIdPool++;
        const response = new ChatResponseModel(requestId, this, message.agentId);
        const request = new ChatRequestModel(requestId, this, message, response);
        tslib_1.__classPrivateFieldGet(this, _ChatModel_requests, "f").push(request);
        return request;
    }
    acceptResponseProgress(request, progress, quiet) {
        if (request.response.isComplete) {
            throw new Error('acceptResponseProgress: Adding progress to a completed response');
        }
        const { kind } = progress;
        const basicKind = ['content', 'markdownContent', 'asyncContent', 'treeData', 'component'];
        if (basicKind.includes(kind)) {
            request.response.updateContent(progress, quiet);
        }
        else {
            this.logger.error(`Couldn't handle progress: ${JSON.stringify(progress)}`);
        }
    }
    dispose() {
        super.dispose();
        tslib_1.__classPrivateFieldGet(this, _ChatModel_requests, "f").forEach((r) => r.response.dispose());
    }
};
_ChatModel_sessionId = new WeakMap(), _ChatModel_requests = new WeakMap();
ChatModel.requestIdPool = 0;
tslib_1.__decorate([
    (0, di_1.Autowired)(ide_core_common_1.ILogger),
    tslib_1.__metadata("design:type", Object)
], ChatModel.prototype, "logger", void 0);
ChatModel = ChatModel_1 = tslib_1.__decorate([
    (0, di_1.Injectable)({ multiple: true })
], ChatModel);
exports.ChatModel = ChatModel;
let ChatWelcomeMessageModel = ChatWelcomeMessageModel_1 = class ChatWelcomeMessageModel extends ide_core_common_1.Disposable {
    get id() {
        return this._id;
    }
    constructor(content, sampleQuestions) {
        super();
        this.content = content;
        this.sampleQuestions = sampleQuestions;
        this._id = 'welcome_' + ChatWelcomeMessageModel_1.nextId++;
    }
};
ChatWelcomeMessageModel.nextId = 0;
ChatWelcomeMessageModel = ChatWelcomeMessageModel_1 = tslib_1.__decorate([
    (0, di_1.Injectable)({ multiple: true }),
    tslib_1.__metadata("design:paramtypes", [Object, Array])
], ChatWelcomeMessageModel);
exports.ChatWelcomeMessageModel = ChatWelcomeMessageModel;
let ChatSlashCommandItemModel = class ChatSlashCommandItemModel extends ide_core_common_1.Disposable {
    constructor(chatCommand, command, agentId) {
        super();
        this.chatCommand = chatCommand;
        this.command = command;
        this.agentId = agentId;
    }
    get name() {
        return this.chatCommand.name;
    }
    get isShortcut() {
        return !!this.chatCommand.isShortcut;
    }
    get icon() {
        return this.chatCommand.icon;
    }
    get description() {
        return this.chatCommand.description;
    }
    get tooltip() {
        return this.chatCommand.tooltip;
    }
    get nameWithSlash() {
        return this.name.startsWith(common_1.AI_SLASH) ? this.name : `${common_1.AI_SLASH}${this.name} `;
    }
};
ChatSlashCommandItemModel = tslib_1.__decorate([
    (0, di_1.Injectable)({ multiple: true }),
    tslib_1.__metadata("design:paramtypes", [Object, String, String])
], ChatSlashCommandItemModel);
exports.ChatSlashCommandItemModel = ChatSlashCommandItemModel;
//# sourceMappingURL=chat-model.js.map