"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatService = void 0;
const tslib_1 = require("tslib");
const di_1 = require("@opensumi/di");
const ide_core_common_1 = require("@opensumi/ide-core-common");
const msg_history_manager_1 = require("../model/msg-history-manager");
let ChatService = class ChatService extends ide_core_common_1.Disposable {
    constructor() {
        super(...arguments);
        this._onChatMessageLaunch = new ide_core_common_1.Emitter();
        this.onChatMessageLaunch = this._onChatMessageLaunch.event;
        this._onChatReplyMessageLaunch = new ide_core_common_1.Emitter();
        this.onChatReplyMessageLaunch = this._onChatReplyMessageLaunch.event;
    }
    sendMessage(data) {
        this._onChatMessageLaunch.fire(data);
    }
    /**
     * 主动以 ai role 的身份回复消息
     */
    sendReplyMessage(data) {
        this._onChatReplyMessageLaunch.fire(data);
    }
    getHistoryMessages() {
        return this.msgHistoryManager.getMessages();
    }
};
tslib_1.__decorate([
    (0, di_1.Autowired)(msg_history_manager_1.MsgHistoryManager),
    tslib_1.__metadata("design:type", msg_history_manager_1.MsgHistoryManager)
], ChatService.prototype, "msgHistoryManager", void 0);
ChatService = tslib_1.__decorate([
    (0, di_1.Injectable)()
], ChatService);
exports.ChatService = ChatService;
//# sourceMappingURL=chat.api.service.js.map