import { Disposable } from '@opensumi/ide-core-common';
import { IChatWelcomeMessageContent, ISampleQuestions } from '../../common';
import { IChatFeatureRegistry, IChatSlashCommandHandler, IChatSlashCommandItem } from '../types';
import { ChatSlashCommandItemModel, ChatWelcomeMessageModel } from './chat-model';
export declare class ChatFeatureRegistry extends Disposable implements IChatFeatureRegistry {
    private readonly logger;
    private slashCommandsMap;
    private slashCommandsHandlerMap;
    chatWelcomeMessageModel?: ChatWelcomeMessageModel;
    dispose(): void;
    registerWelcome(content: IChatWelcomeMessageContent, sampleQuestions: ISampleQuestions[]): void;
    registerSlashCommand(command: IChatSlashCommandItem, handler: IChatSlashCommandHandler): void;
    getSlashCommandHandler(name: string): IChatSlashCommandHandler | undefined;
    getSlashCommand(name: string): ChatSlashCommandItemModel | undefined;
    getSlashCommandHandlerBySlashName(slashName: string): IChatSlashCommandHandler | undefined;
    getSlashCommandBySlashName(slashName: string): ChatSlashCommandItemModel | undefined;
    getAllSlashCommand(): ChatSlashCommandItemModel[];
    getAllShortcutSlashCommand(): ChatSlashCommandItemModel[];
    parseSlashCommand(value: string): {
        value: string;
        nameWithSlash: string;
    };
}
//# sourceMappingURL=chat.feature.registry.d.ts.map