import { PreferenceService } from '@opensumi/ide-core-browser';
import { CancelResponse, CancellationTokenSource, Disposable, ErrorResponse, Event, IAIBackService, IAIBackServiceOption, ReplyResponse } from '@opensumi/ide-core-common';
import { ChatModel, ChatRequestModel } from './chat-model';
/**
 * @internal
 */
export declare class ChatInternalService extends Disposable {
    #private;
    aiBackService: IAIBackService;
    protected preferenceService: PreferenceService;
    private readonly msgStreamManager;
    private readonly aiReporter;
    private chatManagerService;
    private readonly _onChangeSessionId;
    readonly onChangeSessionId: Event<string>;
    private _latestSessionId;
    get latestSessionId(): string;
    get sessionModel(): ChatModel;
    constructor();
    cancelIndicatorChatView: CancellationTokenSource;
    cancelChatViewToken(): void;
    destroyStreamRequest(sessionId: string): Promise<void>;
    /**
     * by backend service
     * @param message
     */
    onMessage(message: string, sessionId: string): void;
    messageWithStream(input: string, options: IAIBackServiceOption | undefined, sessionId: string): Promise<void>;
    message(input: string, options?: IAIBackServiceOption): Promise<ReplyResponse | ErrorResponse | CancelResponse>;
    setLatestSessionId(id: string): void;
    createRequest(input: string, agentId: string, command?: string): ChatRequestModel | undefined;
    sendRequest(request: ChatRequestModel, regenerate?: boolean): Promise<void>;
    cancelRequest(): void;
    clearSessionModel(): void;
    dispose(): void;
}
//# sourceMappingURL=chat.internal.service.d.ts.map