"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractIcon = exports.createMessageByAI = exports.createMessageByUser = void 0;
const ide_core_browser_1 = require("@opensumi/ide-core-browser");
const ME_NAME = '';
const createMessage = (message) => (Object.assign(Object.assign({}, message), { type: 'text', className: `${message.position === 'left' ? 'rce-ai-msg' : 'rce-user-msg'} ${message.className ? message.className : ''}` }));
const createMessageByUser = (message, className) => createMessage(Object.assign(Object.assign({}, message), { position: 'right', title: ME_NAME, className, role: 1 /* ChatMessageRole.User */ }));
exports.createMessageByUser = createMessageByUser;
const createMessageByAI = (message, className) => createMessage(Object.assign(Object.assign({}, message), { position: 'left', title: '', className, role: 2 /* ChatMessageRole.Assistant */ }));
exports.createMessageByAI = createMessageByAI;
const extractIcon = (question) => {
    let { title } = question;
    const { message, tooltip } = question;
    if (!title) {
        return {
            icon: '',
            title: message,
            message,
            tooltip,
        };
    }
    let icon;
    const iconMatched = title.match(/^\$\(([a-z.]+\/)?([a-z0-9-]+)(~[a-z]+)?\)/i);
    if (iconMatched) {
        const [matchedStr, owner, name, modifier] = iconMatched;
        const iconOwner = owner ? owner.slice(0, -1) : ide_core_browser_1.CODICON_OWNER;
        icon = (0, ide_core_browser_1.getExternalIcon)(name, iconOwner);
        if (modifier) {
            icon += ` ${modifier.slice(1)}`;
        }
        title = title.slice(matchedStr.length);
    }
    return {
        icon,
        title,
        message,
        tooltip,
    };
};
exports.extractIcon = extractIcon;
//# sourceMappingURL=utils.js.map