"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReqStack = exports.preSuffixHandler = exports.prePromptHandler = void 0;
const tslib_1 = require("tslib");
const constants = tslib_1.__importStar(require("./constants"));
function prePromptHandler(prompt) {
    // remove all empty lines
    prompt = prompt.replace(/^s*[\n]/gm, '');
    const arr = prompt.split('\n');
    // if the number of lines is greater than n, take the last n lines
    if (arr.length > constants.completionModel.completionPromptMaxLineSize) {
        prompt = arr.slice(-constants.completionModel.completionPromptMaxLineSize).join('\n');
    }
    return prompt;
}
exports.prePromptHandler = prePromptHandler;
function preSuffixHandler(suffix) {
    suffix = suffix.replace(/^s*[\n]/gm, '');
    const arr = suffix.split('\n');
    if (arr.length > constants.completionModel.completionSuffixMaxLineSize) {
        suffix = arr.slice(-constants.completionModel.completionSuffixMaxLineSize).join('\n');
    }
    return suffix;
}
exports.preSuffixHandler = preSuffixHandler;
class ReqStack {
    constructor() {
        this.queue = [];
    }
    addReq(reqRequest) {
        this.queue.push(reqRequest);
    }
    runReq() {
        if (this.queue.length === 0) {
            return;
        }
        const fn = this.queue.pop();
        return fn.sendRequest();
    }
    cancleRqe() {
        if (this.queue.length === 0) {
            return;
        }
        this.queue.forEach((item) => {
            item.cancelRequest();
        });
        this.queue = [];
    }
}
exports.ReqStack = ReqStack;
//# sourceMappingURL=provider.js.map