import { Disposable, IAICompletionResultModel, IAIReportCompletionOption } from '@opensumi/ide-core-common';
import { CompletionRT } from '@opensumi/ide-core-common/lib/types/ai-native/reporter';
import { IProvideInlineCompletionsSignature } from '../../types';
import { CompletionRequestBean } from '../model/competionModel';
export declare class AICompletionsService extends Disposable {
    static readonly STATUS_ID = "ai_completion_status";
    private readonly aiBackService;
    private readonly statusBarService;
    private readonly aiReporter;
    private cancelIndicator;
    protected isDefaultCompletionModel: boolean;
    private isVisibleCompletion;
    private lastSessionId;
    private lastRelationId;
    private lastRenderTime;
    private lastCompletionUseTime;
    private lastMiddlewareInlineCompletion?;
    private recordRenderTime;
    private recordCompletionUseTime;
    complete(data: CompletionRequestBean, model: any, position: any, token: any): Promise<IAICompletionResultModel | null>;
    setMiddlewareComplete(provideInlineCompletions: IProvideInlineCompletionsSignature): void;
    report(data: IAIReportCompletionOption): Promise<void>;
    reporterEnd(relationId: string, data: CompletionRT): Promise<void>;
    setVisibleCompletion(visible: boolean): void;
    setLastSessionId(sessionId: string): void;
    setLastRelationId(relationId: string): void;
    cancelRequest(): Promise<void>;
    updateStatusBarItem(content: string, isLoading: boolean): void;
    hideStatusBarItem(): void;
}
//# sourceMappingURL=ai-completions.service.d.ts.map