"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GolangLanguageFacts = void 0;
/**
 * go 中表示代码块的节点类型
 */
const goLangBlockCodeTypes = [
    'function_declaration',
    'method_declaration',
    'block',
    'if_statement',
    'else_statement',
    'switch_statement',
    'case_clause',
    'for_statement',
    'range_clause',
    'type_switch_statement',
    'type_case_clause',
    'comm_clause',
    'select_statement',
    'go_statement',
    'defer_statement',
];
const blockSet = new Set(goLangBlockCodeTypes);
class GolangLanguageFacts {
    constructor() {
        this.name = 'go';
        this.listCommentStyle = '// ';
        this.blockCommentStyle = {
            start: '/**',
            end: ' */',
            linePrefix: ' * ',
        };
    }
    provideCodeBlocks() {
        return blockSet;
    }
    isCodeBlock(type) {
        return blockSet.has(type);
    }
}
exports.GolangLanguageFacts = GolangLanguageFacts;
//# sourceMappingURL=golang.js.map