"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JavaLanguageFacts = void 0;
/**
 * java 中表示代码块的节点类型
 */
const javaBlockCodeTypes = [
    'compilation_unit',
    'class_declaration',
    'interface_declaration',
    'enum_declaration',
    'method_declaration',
    'constructor_declaration',
    'block',
    'static_initializer',
    'instance_initializer',
    'if_statement',
    'switch_statement',
    'while_statement',
    'do_statement',
    'for_statement',
    'enhanced_for_statement',
    'try_statement',
    'catch_clause',
    'finally_clause',
];
const functionCodeBlocks = new Set(['method_declaration', 'constructor_declaration']);
const blockSet = new Set(javaBlockCodeTypes);
class JavaLanguageFacts {
    constructor() {
        this.name = 'java';
        this.listCommentStyle = '// ';
        this.blockCommentStyle = {
            start: '/**',
            end: ' */',
            linePrefix: ' * ',
        };
    }
    provideCodeBlocks() {
        return blockSet;
    }
    isCodeBlock(type) {
        return blockSet.has(type);
    }
    isFunctionCodeBlocks(type) {
        return functionCodeBlocks.has(type);
    }
}
exports.JavaLanguageFacts = JavaLanguageFacts;
//# sourceMappingURL=java.js.map