"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JavaScriptReactLanguageFacts = exports.javascriptreactBlockCodeTypes = void 0;
const javascript_1 = require("./javascript");
/**
 * jsx 中表示代码块的节点类型
 * 与 javascript 中的基础节点类型一致
 */
exports.javascriptreactBlockCodeTypes = [
    ...javascript_1.javascriptBlockCodeTypes,
    'jsx_element',
    'jsx_self_closing_element',
    'jsx_expression',
    'jsx_fragment',
];
const blockSet = new Set(exports.javascriptreactBlockCodeTypes);
class JavaScriptReactLanguageFacts {
    constructor() {
        this.name = 'jsx';
        this.listCommentStyle = '// ';
        this.blockCommentStyle = {
            start: '/**',
            end: ' */',
            linePrefix: ' * ',
        };
    }
    provideCodeBlocks() {
        return blockSet;
    }
    isCodeBlock(type) {
        return blockSet.has(type);
    }
}
exports.JavaScriptReactLanguageFacts = JavaScriptReactLanguageFacts;
//# sourceMappingURL=javascriptreact.js.map