"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PythonLanguageFacts = exports.pythonBlockCodeTypes = void 0;
/**
 * python 中表示代码块的节点类型
 */
exports.pythonBlockCodeTypes = [
    'function_definition',
    'class_definition',
    'compound_statement',
    'if_statement',
    'elif_clause',
    'else_clause',
    'for_statement',
    'while_statement',
    'try_statement',
    'except_clause',
    'with_statement',
    'decorated_definition',
];
const blockSet = new Set(exports.pythonBlockCodeTypes);
class PythonLanguageFacts {
    constructor() {
        this.name = 'python';
        this.listCommentStyle = '# ';
        this.blockCommentStyle = {
            start: "'''",
            end: "'''",
            linePrefix: '',
        };
    }
    provideCodeBlocks() {
        return blockSet;
    }
    isCodeBlock(type) {
        return blockSet.has(type);
    }
}
exports.PythonLanguageFacts = PythonLanguageFacts;
//# sourceMappingURL=python.js.map