"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RustLanguageFacts = exports.rustBlockCodeTypes = void 0;
/**
 * rust 中表示代码块的节点类型
 */
exports.rustBlockCodeTypes = [
    'function_item',
    'impl_item',
    'trait_item',
    'block',
    'if_expression',
    'match_expression',
    'while_expression',
    'loop_expression',
    'for_expression',
    'closure_expression',
    'struct_item',
    'enum_item',
    'union_item',
    'mod_item',
];
const blockSet = new Set(exports.rustBlockCodeTypes);
class RustLanguageFacts {
    constructor() {
        this.name = 'rust';
        this.listCommentStyle = '// ';
        this.blockCommentStyle = {
            start: '/**',
            end: ' */',
            linePrefix: ' * ',
        };
    }
    provideCodeBlocks() {
        return blockSet;
    }
    isCodeBlock(type) {
        return blockSet.has(type);
    }
}
exports.RustLanguageFacts = RustLanguageFacts;
//# sourceMappingURL=rust.js.map