"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeScriptReactLanguageFacts = exports.typescriptreactBlockTypes = void 0;
const typescript_1 = require("./typescript");
/**
 * tsx 中表示代码块的节点类型
 * 与 typescript 中的基础节点类型一致
 */
exports.typescriptreactBlockTypes = [
    ...typescript_1.typescriptBlockTypes,
    'jsx_element',
    'jsx_self_closing_element',
    'jsx_expression',
    'jsx_fragment',
];
const blockSet = new Set(exports.typescriptreactBlockTypes);
class TypeScriptReactLanguageFacts {
    constructor() {
        this.name = 'tsx';
        this.listCommentStyle = '// ';
        this.blockCommentStyle = {
            start: '/**',
            end: ' */',
            linePrefix: ' * ',
        };
    }
    provideCodeBlocks() {
        return blockSet;
    }
    isCodeBlock(type) {
        return blockSet.has(type);
    }
}
exports.TypeScriptReactLanguageFacts = TypeScriptReactLanguageFacts;
//# sourceMappingURL=typescriptreact.js.map