"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AIRightTabRenderer = exports.AILeftTabRenderer = exports.AIChatTabRenderer = void 0;
const tslib_1 = require("tslib");
const classnames_1 = tslib_1.__importDefault(require("classnames"));
const react_1 = tslib_1.__importStar(require("react"));
const ide_core_browser_1 = require("@opensumi/ide-core-browser");
const ai_native_1 = require("@opensumi/ide-core-browser/lib/components/ai-native");
const constants_1 = require("@opensumi/ide-core-browser/lib/layout/constants");
const ide_core_common_1 = require("@opensumi/ide-core-common");
const tabbar_view_1 = require("@opensumi/ide-design/lib/browser/layout/tabbar.view");
const ide_main_layout_1 = require("@opensumi/ide-main-layout");
const bar_view_1 = require("@opensumi/ide-main-layout/lib/browser/tabbar/bar.view");
const panel_view_1 = require("@opensumi/ide-main-layout/lib/browser/tabbar/panel.view");
const renderer_view_1 = require("@opensumi/ide-main-layout/lib/browser/tabbar/renderer.view");
const tabbar_service_1 = require("@opensumi/ide-main-layout/lib/browser/tabbar/tabbar.service");
const common_1 = require("../../common");
const layout_module_less_1 = tslib_1.__importDefault(require("./layout.module.less"));
const ChatTabbarRenderer = () => {
    const { side } = react_1.default.useContext(renderer_view_1.TabbarConfig);
    const tabbarService = (0, ide_core_browser_1.useInjectable)(tabbar_service_1.TabbarServiceFactory)(side);
    (0, react_1.useEffect)(() => {
        tabbarService.setIsLatter(true);
    }, [tabbarService]);
    return (react_1.default.createElement("div", { style: { width: 0 } },
        react_1.default.createElement(bar_view_1.TabbarViewBase, { tabSize: 0, MoreTabView: bar_view_1.IconElipses, TabView: bar_view_1.IconTabView, barSize: 0, panelBorderSize: 1 })));
};
const AIChatTabRenderer = ({ className, components, }) => (react_1.default.createElement(renderer_view_1.TabRendererBase, { side: common_1.AI_CHAT_VIEW_ID, direction: "left-to-right" /* EDirection.LeftToRight */, id: layout_module_less_1.default.ai_chat_panel, className: (0, classnames_1.default)(className, `${common_1.AI_CHAT_VIEW_ID}-slot`), components: components, TabbarView: () => react_1.default.createElement(ChatTabbarRenderer, null), TabpanelView: () => (react_1.default.createElement(panel_view_1.BaseTabPanelView, { PanelView: panel_view_1.ContainerView, PanelViewProps: {
            className: layout_module_less_1.default.ai_chat_view_container,
        } })) }));
exports.AIChatTabRenderer = AIChatTabRenderer;
const AILeftTabRenderer = ({ className, components, }) => react_1.default.createElement(tabbar_view_1.DesignLeftTabRenderer, { className: className, components: components, tabbarView: AILeftTabbarRenderer });
exports.AILeftTabRenderer = AILeftTabRenderer;
const AILeftTabbarRenderer = () => {
    const tabbarService = (0, ide_core_browser_1.useInjectable)(tabbar_service_1.TabbarServiceFactory)(ide_core_browser_1.SlotLocation.right);
    const layoutService = (0, ide_core_browser_1.useInjectable)(ide_main_layout_1.IMainLayoutService);
    const extraMenus = react_1.default.useMemo(() => layoutService.getExtraMenu(), [layoutService]);
    const [navMenu] = (0, ide_core_browser_1.useContextMenus)(extraMenus);
    const renderOtherVisibleContainers = (0, react_1.useCallback)(({ renderContainers }) => {
        const { currentContainerId, handleTabClick } = tabbarService;
        const visibleContainers = tabbarService.visibleContainers.filter((container) => { var _a; return !((_a = container.options) === null || _a === void 0 ? void 0 : _a.hideTab); });
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(ai_native_1.HorizontalVertical, { margin: '8px auto 0px', width: '60%' }),
            visibleContainers.map((component) => renderContainers(component, handleTabClick, currentContainerId))));
    }, [tabbarService]);
    return (react_1.default.createElement(bar_view_1.LeftTabbarRenderer, { renderOtherVisibleContainers: renderOtherVisibleContainers, isRenderExtraTopMenus: false, renderExtraMenus: react_1.default.createElement("div", { className: layout_module_less_1.default.extra_bottom_icon_container }, navMenu.length >= 0
            ? navMenu.map((menu) => (react_1.default.createElement(ai_native_1.EnhanceIconWithCtxMenu, { key: menu.id, wrapperClassName: layout_module_less_1.default.extra_bottom_icon, iconClass: menu.icon, menuNodes: menu.children, skew: { x: -8, y: -4 } })))
            : null) }));
};
const AIRightTabRenderer = ({ className, components, }) => {
    const tabbarService = (0, ide_core_browser_1.useInjectable)(tabbar_service_1.TabbarServiceFactory)(ide_core_browser_1.SlotLocation.right);
    const designLayoutConfig = (0, ide_core_browser_1.useInjectable)(constants_1.DesignLayoutConfig);
    const handleClose = (0, react_1.useCallback)(() => {
        tabbarService.updateCurrentContainerId('');
    }, []);
    const ContainerViewFn = (0, react_1.useCallback)((props) => {
        const { component } = props;
        const { options } = component;
        return (react_1.default.createElement(panel_view_1.ContainerView, Object.assign({}, props, { renderContainerWrap: ({ children }) => (react_1.default.createElement("div", { className: layout_module_less_1.default.right_slot_container_wrap },
                react_1.default.createElement("div", { className: layout_module_less_1.default.header },
                    react_1.default.createElement("span", { className: layout_module_less_1.default.title }, options && options.title),
                    react_1.default.createElement("div", { className: layout_module_less_1.default.side },
                        react_1.default.createElement(ai_native_1.EnhancePopover, { id: 'ai_right_panel_header_close', title: (0, ide_core_common_1.localize)('editor.title.context.close') },
                            react_1.default.createElement(ai_native_1.EnhanceIcon, { icon: 'close', onClick: handleClose })))),
                react_1.default.createElement("div", { className: layout_module_less_1.default.container }, children))) })));
    }, []);
    const rightTabRenderClassName = (0, react_1.useMemo)(() => (designLayoutConfig.useMergeRightWithLeftPanel ? layout_module_less_1.default.right_tab_renderer : ''), [designLayoutConfig]);
    return (react_1.default.createElement(tabbar_view_1.DesignRightTabRenderer, { components: components, className: rightTabRenderClassName, tabbarView: () => react_1.default.createElement(bar_view_1.RightTabbarRenderer, { barSize: 0, style: { width: 0 } }), tabpanelView: () => react_1.default.createElement(panel_view_1.BaseTabPanelView, { PanelView: ContainerViewFn }) }));
};
exports.AIRightTabRenderer = AIRightTabRenderer;
//# sourceMappingURL=tabbar.view.js.map