"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResolveConflictRegistry = void 0;
const tslib_1 = require("tslib");
const di_1 = require("@opensumi/di");
const ide_core_common_1 = require("@opensumi/ide-core-common");
let ResolveConflictRegistry = class ResolveConflictRegistry extends ide_core_common_1.Disposable {
    constructor() {
        super(...arguments);
        this.providerMap = new Map();
    }
    dispose() {
        super.dispose();
    }
    registerResolveConflictProvider(editorMode, handler) {
        if (this.providerMap.has(editorMode)) {
            throw new Error(`Conflict provider for ${editorMode} already exists`);
        }
        this.providerMap.set(editorMode, handler);
    }
    getThreeWayHandler() {
        return this.providerMap.get(ide_core_common_1.MergeConflictEditorMode['3way']);
    }
    getTraditionalHandler() {
        return this.providerMap.get(ide_core_common_1.MergeConflictEditorMode.traditional);
    }
};
ResolveConflictRegistry = tslib_1.__decorate([
    (0, di_1.Injectable)()
], ResolveConflictRegistry);
exports.ResolveConflictRegistry = ResolveConflictRegistry;
//# sourceMappingURL=merge-conflict.feature.registry.js.map