"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OverrideResolveResultWidget = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const di_1 = require("@opensumi/di");
const containerPanel_1 = require("@opensumi/ide-core-browser/lib/components/ai-native/content-widget/containerPanel");
const ide_core_common_1 = require("@opensumi/ide-core-common");
const line_range_1 = require("@opensumi/ide-monaco/lib/browser/contrib/merge-editor/model/line-range");
const types_1 = require("@opensumi/ide-monaco/lib/browser/contrib/merge-editor/types");
const resultCodeEditor_1 = require("@opensumi/ide-monaco/lib/browser/contrib/merge-editor/view/editors/resultCodeEditor");
const resolve_result_widget_1 = require("@opensumi/ide-monaco/lib/browser/contrib/merge-editor/widget/resolve-result-widget");
let OverrideResolveResultWidget = class OverrideResolveResultWidget extends resolve_result_widget_1.ResolveResultWidget {
    constructor(codeEditor, lineRange) {
        super(codeEditor, lineRange);
        this.codeEditor = codeEditor;
        this.lineRange = lineRange;
        this.uid = (0, ide_core_common_1.uuid)(4);
    }
    isRenderThumbs() {
        return true;
    }
    iconItems() {
        return [
            {
                icon: 'discard',
                text: (0, ide_core_common_1.localize)('aiNative.operate.discard.title'),
                onClick: () => {
                    this.codeEditor.launchConflictActionsEvent({
                        range: this.lineRange,
                        action: types_1.REVOKE_ACTIONS,
                    });
                },
            },
        ];
    }
    renderView() {
        const iconResultItems = this.iconItems();
        const isRenderThumbs = this.isRenderThumbs();
        const handleCloseClick = () => {
            this.codeEditor.launchConflictActionsEvent({
                range: this.lineRange,
                action: types_1.IGNORE_ACTIONS,
            });
        };
        return (react_1.default.createElement(containerPanel_1.ContentWidgetContainerPanel, { style: { transform: 'translateY(4px)' } },
            react_1.default.createElement(resolve_result_widget_1.WapperAiInlineResult, { iconItems: iconResultItems, isRenderThumbs: isRenderThumbs, codeEditor: this.codeEditor, range: this.lineRange, closeClick: handleCloseClick, isRenderClose: true, disablePopover: true })));
    }
    id() {
        return `${types_1.AiResolveConflictContentWidget}_${this.uid}`;
    }
};
OverrideResolveResultWidget = tslib_1.__decorate([
    (0, di_1.Injectable)({ multiple: true }),
    tslib_1.__metadata("design:paramtypes", [resultCodeEditor_1.ResultCodeEditor, line_range_1.LineRange])
], OverrideResolveResultWidget);
exports.OverrideResolveResultWidget = OverrideResolveResultWidget;
//# sourceMappingURL=override-resolve-result-widget.js.map