/// <reference types="react" />
import { Disposable, Event } from '@opensumi/ide-core-common';
import { IChatMessage } from '../../common/index';
export interface IHistoryChatMessage extends IChatMessage {
    id: string;
    order: number;
    type?: 'string' | 'component';
    relationId?: string;
    component?: React.ReactNode;
    componentProps?: {
        [key in string]: any;
    };
    agentId?: string;
    agentCommand?: string;
}
type IExcludeMessage = Omit<IHistoryChatMessage, 'id' | 'order'>;
export declare class MsgHistoryManager extends Disposable {
    private messageMap;
    private readonly _onMessageChange;
    readonly onMessageChange: Event<IHistoryChatMessage[]>;
    private doAddMessage;
    getMessages(): IHistoryChatMessage[];
    addUserMessage(message: Omit<IExcludeMessage, 'role'>): string;
    addAgentMessage(message: Required<Pick<IExcludeMessage, 'agentId' | 'agentCommand' | 'content'>>): string;
    addAssistantMessage(message: Omit<IExcludeMessage, 'role'>): string;
    updateAssistantMessage(id: string, message: Omit<IExcludeMessage, 'role'>): void;
}
export {};
//# sourceMappingURL=msg-history-manager.d.ts.map