import { Disposable, Event } from '@opensumi/ide-core-common';
export interface IMsgStreamChoices {
    delta: {
        content: string;
        role: string;
    };
    finish_reason: null | 'stop' | string;
    index: number;
}
export declare const enum EMsgStreamStatus {
    READY = 0,
    THINKING = 1,
    DONE = 2,
    ERROR = 3,
    PAUSE = 4
}
export declare class MsgStreamManager extends Disposable {
    private sessionIdToAnswerIdMap;
    private answerIdToMsgStreamMap;
    private onDidMsgListChangeDispatcher;
    private _currentSessionId;
    private _status;
    private readonly _onMsgStatus;
    readonly onMsgStatus: Event<EMsgStreamStatus>;
    get status(): EMsgStreamStatus;
    private set status(value);
    get currentSessionId(): string;
    setCurrentSessionId(id: string): void;
    onMsgListChange(sessionId: string): Event<IMsgStreamChoices>;
    sendErrorStatue(): void;
    sendDoneStatue(): void;
    sendThinkingStatue(): void;
    sendPauseStatue(): void;
    recordMessage(answerId: string, msg: IMsgStreamChoices): void;
}
//# sourceMappingURL=msg-stream-manager.d.ts.map