"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RenameSuggestionsService = void 0;
const tslib_1 = require("tslib");
const di_1 = require("@opensumi/di");
const ide_core_common_1 = require("@opensumi/ide-core-common");
let RenameSuggestionsService = class RenameSuggestionsService {
    async provideRenameSuggestions(model, range, token) {
        const providers = this.renameCandidatesProviderRegistry.getRenameSuggestionsProviders();
        const promises = providers.map((provider) => provider(model, range, token));
        const result = (await Promise.all(promises)).filter(Boolean);
        return result.flat();
    }
};
tslib_1.__decorate([
    (0, di_1.Autowired)(ide_core_common_1.RenameCandidatesProviderRegistryToken),
    tslib_1.__metadata("design:type", Object)
], RenameSuggestionsService.prototype, "renameCandidatesProviderRegistry", void 0);
RenameSuggestionsService = tslib_1.__decorate([
    (0, di_1.Injectable)()
], RenameSuggestionsService);
exports.RenameSuggestionsService = RenameSuggestionsService;
//# sourceMappingURL=rename.service.js.map