"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AIRunToolbar = void 0;
const tslib_1 = require("tslib");
const mobx_react_lite_1 = require("mobx-react-lite");
const react_1 = tslib_1.__importDefault(require("react"));
const ide_core_browser_1 = require("@opensumi/ide-core-browser");
const ide_debug_1 = require("@opensumi/ide-debug");
const components_1 = require("@opensumi/ide-debug/lib/browser/components");
const debug_configuration_service_1 = require("@opensumi/ide-debug/lib/browser/view/configuration/debug-configuration.service");
const debug_configuration_view_1 = require("@opensumi/ide-debug/lib/browser/view/configuration/debug-configuration.view");
const debug_toolbar_service_1 = require("@opensumi/ide-debug/lib/browser/view/configuration/debug-toolbar.service");
const debug_toolbar_view_1 = require("@opensumi/ide-debug/lib/browser/view/configuration/debug-toolbar.view");
const run_toolbar_module_less_1 = tslib_1.__importDefault(require("./run-toolbar.module.less"));
const CustomDebugBar = (0, mobx_react_lite_1.observer)(() => {
    const { start } = (0, ide_core_browser_1.useInjectable)(debug_configuration_service_1.DebugConfigurationService);
    return (react_1.default.createElement("div", { className: run_toolbar_module_less_1.default.debug_actions },
        react_1.default.createElement(components_1.DebugAction, { id: 'debug.action.start', icon: 'start', label: (0, ide_core_browser_1.localize)('debug.action.start'), run: start })));
});
exports.AIRunToolbar = (0, mobx_react_lite_1.observer)(() => {
    const { state } = (0, ide_core_browser_1.useInjectable)(debug_toolbar_service_1.DebugToolbarService);
    return (react_1.default.createElement("div", { className: run_toolbar_module_less_1.default.run_toolbar_container },
        react_1.default.createElement("span", { className: run_toolbar_module_less_1.default.dividing }),
        react_1.default.createElement(debug_configuration_view_1.DebugControllerView, { className: run_toolbar_module_less_1.default.debug_controller_view, CustomActionBar: CustomDebugBar }),
        state !== undefined && state !== ide_debug_1.DebugState.Inactive && (react_1.default.createElement(debug_toolbar_view_1.DebugToolbarView, { float: false, className: run_toolbar_module_less_1.default.debug_action_bar_internal }))));
});
//# sourceMappingURL=run-toolbar.js.map