import { AIActionItem } from '@opensumi/ide-core-browser/lib/components/ai-native';
import { CommandRegistry, CommandService, Disposable, IDisposable, IRange } from '@opensumi/ide-core-common';
import { CodeAction } from '@opensumi/ide-monaco';
import { IEditorInlineChatHandler, IInlineChatFeatureRegistry, ITerminalInlineChatHandler } from '../../types';
export declare class InlineChatFeatureRegistry extends Disposable implements IInlineChatFeatureRegistry {
    private readonly logger;
    commandRegistry: CommandRegistry;
    commandService: CommandService;
    private actionsMap;
    private codeActionsMap;
    private editorHandlerMap;
    private terminalHandlerMap;
    dispose(): void;
    private readonly _onCodeActionRun;
    readonly onCodeActionRun: import("@opensumi/ide-core-browser").Event<{
        id: string;
        range: IRange;
    }>;
    static getCommandId(type: 'editor' | 'terminal', id: string): string;
    private collectActions;
    private removeCollectedActions;
    registerEditorInlineChat(operational: AIActionItem, handler: IEditorInlineChatHandler): IDisposable;
    registerTerminalInlineChat(operational: AIActionItem, handler: ITerminalInlineChatHandler): IDisposable;
    getEditorActionButtons(): AIActionItem[];
    getCodeActions(): CodeAction[];
    getEditorActionMenus(): AIActionItem[];
    getEditorHandler(id: string): IEditorInlineChatHandler | undefined;
    getTerminalHandler(id: string): ITerminalInlineChatHandler | undefined;
    getTerminalActions(): AIActionItem[];
    getAction(id: string): AIActionItem | undefined;
}
//# sourceMappingURL=inline-chat.feature.registry.d.ts.map