"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RenamePromptManager = void 0;
const tslib_1 = require("tslib");
const di_1 = require("@opensumi/di");
const base_prompt_manager_1 = require("./base-prompt-manager");
let RenamePromptManager = class RenamePromptManager extends base_prompt_manager_1.BasePromptManager {
    requestPrompt(varName) {
        const prompt = `please rename this variable: \`\`\`\n${varName}\n\`\`\`, put all the possible names in a code block line by line.`;
        return prompt;
    }
    extractResponse(data) {
        const codeBlock = /```([\s\S]*?)```/g;
        const result = data.match(codeBlock);
        if (!result) {
            return [];
        }
        const lines = result[0].replace(/```/g, '').trim().split('\n');
        return lines;
    }
};
RenamePromptManager = tslib_1.__decorate([
    (0, di_1.Injectable)()
], RenamePromptManager);
exports.RenamePromptManager = RenamePromptManager;
//# sourceMappingURL=rename-prompt.js.map